0REM   from Gordon Meyer's collection 2608 W.6000 S.,Roy ,UTAH  84067
5POKE 16956, 3:POKE 16957, 29
10TEXT:HOME
20SPEED =45
25INVERSE
30? "TJ NUCLEAR POWER PLANT"
35NORMAL
40?:? "This program simulates the"
50? "operation of a nuclear power"
60? "reactor."
65? "The object is to operate"
70? "the plant at a maximum average"
75? "power output without causing a"
80? "reactor meltdown.":?
90? "The control rods adjust the"
100? "amount of heat produced by the"
110? "reactor. Primary coolant"
120? "transfers this heat to the"
130? "heat exchanger. Secondary"
140? "coolant transfers heat from"
150? "the heat exchanger to the"
160? "turbine, where power is "
170? "produced, and finally to the"
180? "cooling tower."
185?
190? "The emergency coolant is used"
200? "to help shut down the reactor"
205? "when the other systems fail."
210? "Unlike the other coolants,"
212? "emergency coolant is not"
215? "recycled."
216?:?
220? "ENTER`D`TO SEE REACTOR DIAGRAM":? "ENTER`I`FOR INSTRUCTIONS":? "ENTER`S`TO START OPERATION"
221GET a$
222IF a$="D" OR a$="d" THEN GOSUB 6000:GOTO 220
223IF a$="S" OR a$="s" THEN GOTO 390
225TEXT:HOME
230? "The controls are operated by"
235? "typing in the desired control"
240? "rod settings and flow rates."
242? "(Use values from 0 to 100)"
245? "If no entry is made, the"
250? "values won't change. Use the"
252? "`space`bar to step to the"
255? "different functions.When the"
260? "desired entries have been"
265? "made, use the`return`key to"
268? "to advance to the next day."
270?:? "The reactor can be operated"
275? "until a meltdown occures or"
278? "the reactor fuel is exhausted."
280? "The fuel will last for about"
285? "100 to 150 days."
290? "When the fuel is exhausted"
292? "your performance will be "
295? "evaluated."
298? "(press `RETURN` to continue)":INPUT a$:HOME
300? "If you want to repair damage"
305? "or replace coolant, bring the"
310? "reactor temperture down below"
312? "100 and shut off coolant flows"
315? "This will cause an automatic"
320? "maintenance shutdown and"
325? "all coolant will be replenished"
330? "and repairs made.":? "THe greater the damage"
335? "the longer repairs will take."
336FLASH
340?:?:? "WARNING: THIS REACTOR HAS"
345? "NO AUTOMATIC SAFTY DEVICES!!":?:?
350NORMAL
380GOTO 220
390& ***INITIATE***
400GOSUB 2000
410LET rh=0:LET rl=0:LET day%=0:LET tt=0:LET dmge%=0
420LET a%=0:LET a1%=0:LET a2%=0
460& ***WRITE REPORT***
470TEXT:HOME
475 day%=day%+1
480? TAB(7); "TJ NUCLEAR POWER PLANT"
490? TAB(8); "STATUS REPORT - DAY "; day%
500?
510? "WARNINGS:"
520IF rt%>800 THEN ? "REACTOR OVERHEATED": rd%=rd%+1+(rt%>850)+(rt%>900)+2*(rt%>950): pd%=pd%+1: ed%=ed%+1+(rt%>850)
530IF xt%>500 THEN ? "HEAT EXCHANGER OVERHEATED": xd%=xd%+1+(xt%>600): pd%=pd%+1: sd%=sd%+1
540IF go%>2000 THEN ? "TURBINE OVERLOADED": td%=td%+1+(go%>2500): sd%=sd%+1
550IF ct%>300 THEN ? "COOLING TOWER OVERHEATED": sd%=sd%+1
560IF go%<1000 THEN ? "POWER OUTPUT LOW"
570IF ev%<200 THEN ? "EMERGENCY COOLANT LOW"
580IF pv%<100 THEN ? "PRIMARY COOLANT LOW": pd%=pd%+1
590IF sv%<100 THEN ? "SECONDARY COOLANT LOW": sd%=sd%+1
595IF rl>85 THEN ? "FUEL LOW"
600?:? "DAMAGE:"
620IF rd%>3 THEN ? "REACTOR CORE DAMAGED"
630IF pd%>4 THEN ? "PRIMARY COOLANT LEAK - "; pd%; " /DAY"
635 pv%=(pv%-pd%)*((pv%-pd%)>0)
640IF sd%>4 THEN ? "SECONDARY COOLANT LEAK - "; sd%; " /DAY": sv%=(sv%-sd%)*((sv%-sd%)>0)
650IF ed%>2 THEN ? "EMERGENCY COOLANT LEAK - "; 2*ed%; " /DAY"; ev%=(ev%-2*ed%)*((ev%-2*ed%)>0)
660IF pb% THEN ? "PRIMARY COOLANT PUMP FAILURE - "; 10*pd%*(pd%<10)+100*(pd%>=10); "%"
670IF sb% THEN ? "SECONDARY COOLANT PUMP FAILURE - "; 10*sd%*(sd%<10)+100*(sd%>=10); "%"
680IF xb% THEN ? "HEAT EXCHANGER FAILURE"
690IF gb% THEN ? "TURBINE FAILURE"
710IF rd%>5 THEN GOTO 3000
720SPEED =255
725? "INDICATORS:"
730? "CORE TEMP      (MAX 800) "; rt%
740? "EXCHANGER TEMP (MAX 500) "; xt%
750? "TOWER TEMP     (MAX 300) "; ct%
760? "POWER OUTPUT (MAX 2000KW) "; go%; " KW"
765 kw%=tt/day%
770? "AVERAGE PWR OUTPUT "; kw%; "KW/DAY"
800? "CONTROL RODS- "; a%
810? "COOLANT LEVELS:"
820? "EMERGENCY- "; ev%; " FLOW- "; ef%
830? "PRIMARY  - "; pv%; " FLOW- "; pf%
840? "SECONDARY- "; sv%; " FLOW- "; sf%
850IF (100-rl)<5 THEN ?:?:?:? "REACTOR FUEL EXHAUSTED":GOTO 4000
900REM                 ****GET NEW CONTROL VALUES******
910 p=VPOS(1)
920VTAB (p-4)
930HTAB (15)
950 a2%=a1%: a1%=a%
955 b$="":FOR i=1 TO 4
960GET a$: z=ASC(a$)
962IF z=63 THEN HOME:GOTO 5000
965IF (z<>13 AND z<>32) AND (z>57 OR z<48) THEN 960
970 b$=b$+a$:IF z=13 THEN 1170
975IF z=32 THEN 990
980 a%=VAL(b$): a%=a%+(100-a%)*(a%>100)
985? a$; :NEXT i
990VTAB (p-2):HTAB (29)
1005 b$="":FOR i=1 TO 4
1010GET a$: z=ASC(a$)
1015IF (z<>13 AND z<>32) AND (z>57 OR z<48) THEN 1010
1020 b$=b$+a$:IF z=13 THEN 1170
1025IF z=32 THEN 1050
1030 ef%=VAL(b$): ef%=ef%+(100-ef%)*(ef%>100)
1035IF ef%>ev% THEN  ef%=ev%
1040? a$; :NEXT i
1050VTAB (p-1):HTAB (29)
1065 b$="":FOR i=1 TO 4
1070GET a$: z=ASC(a$)
1075IF (z<>13 AND z<>32) AND (z>57 OR z<48) THEN 1070
1080 b$=b$+a$:IF z=13 THEN 1170
1085IF z=32 THEN 1110
1090 pf%=VAL(b$): pf%=pf%+(100-pf%)*(pf%>100)
1100? a$; :NEXT i
1110VTAB (p):HTAB (29)
1125 b$="":FOR i=1 TO 4
1130GET a$: z=ASC(a$)
1135IF (z<>13 AND z<>32) AND (z>57 OR z<48) THEN 1130
1140 b$=b$+a$:IF z=13 THEN 1170
1145IF z=32 THEN 1165
1150 sf%=VAL(b$): sf%=sf%+(100-sf%)*(sf%>100)
1160? a$; :NEXT i
1165HTAB (1):VTAB (p-3):CALL -958:GOTO 800
1170IF pf%=0 AND sf%=0 AND rh<1 AND rt%<100 AND a%=0 THEN GOTO 1175
1171GOTO 1180
1175GOSUB 2000:HTAB (1):VTAB (24):CALL -922:? "MAINTENANCE SHUTDOWN- "; md%; " DAYS."
1176FOR a=1 TO 10000:NEXT a
1180IF ef%>ev% THEN  ef%=ev%
1200& **DAMAGE ESSESSMENT &  OPERATION CALCULATIONS**
1205 ev%=ev%-ef%-2*ed%*(ed%>3)
1210 pd%=pd%+(pf%>90)*(RND(20)>.95)
1220 sd%=sd%+(sf%>90)*(RND(20)>.92)
1230 pb%=pd%>5
1240 sb%=sd%>5
1250IF pf%>(100-pd%*10) AND pb% THEN  pf%=(100-pd%*10)*(100-pd%*10>0)
1260IF sf%>(100-sd%*10) AND sb% THEN  sf%=(100-sd%*10)*(100-sd%*10>0)
1270 rl=rl+rh/50
1280 rh=(a%*30+a1%*60+a2%*10)/2500*(100-rl)
1300 ph=pf%*(100*(pv%>100)+pv%*(pv%<=100))/350
1310 eh=ef%/200*(rt%-25)
1320 rt%=rt%+rh-eh-ph-5*(rt%>25)
1325 rt%=25+(rt%-25)*(rt%>25)
1330 xt%=((rt%-25)*pf%+(ct%-25)*sf%)/(pf%+sf%+1)+25
1340IF xb% THEN  xt%=rt%*.8+5
1350 sh=sf%*(100*(pv%>100)+pv%*(pv%<=100))/350*(xt%-ct%)
1360IF xb% THEN  sh=sh*.2
1370 go%=sh/xt%*(xt%-ct%)*2/3
1375IF go%>2600 THEN  go%=2600
1380 go%=go%*(go%>0)*(gb%=0)
1390 ct%=25+((xt%-25)*(sh-go%)/(sh+1)*.75)
1395 ct%=25*(ct%<=25)+ct%*(ct%>25)
1400IF xb%<1 THEN  xb%=(xd%>2)*(RND(4)>.9)
1410IF gb%<1 THEN  gb%=(gd%>4)*(RND(4)>.9)
1420 tt=tt+go%
1430GOTO 470
2000& ****MAINTENANCE REPAIR SUBROUNTINE***
2010 ev%=300
2020 pv%=120
2030 sv%=120
2040 rt%=25
2050 xt%=25
2060 ct%=25
2070 dmge%=dmge%+2*rd%+ed%+pd%+xd%+sd%+gd%
2080 md%=5+3*(10*(rd%>3)+(ed%>3)+(pd%>3)+(sd%>3)+2*pb%+2*sb%+3*xb%+3*gb%): day%=day%+md%
2090 rd%=0
2100 ed%=0
2110 pd%=0
2120 xd%=0
2130 sd%=0
2140 gd%=0
2150 pb%=0
2160 sb%=0
2170 xb%=0
2180 gb%=0
2190 ef%=0: pf%=0: sf%=0
2195 go%=0
2200RETURN
3000& ***MELTDOWN ENDING***
3010GOSUB 8000
3020IF rd%>6 THEN 3100
3030?:? "THE REACTOR CORE HAS BEEN":? "DESTROYED BY UNCONTROLED"
3040? "THERMAL RUNAWAY, HOWEVER":? "THE CONTAINER BUILDING HAS NOT YET RUPTURED!"
3080? "INITIATE YOUR EVACUATION PLAN."
3090GOTO 5000
3100? "THE REACTOR CORE HAS MELTED":? "DOWN AND PRODUCED A STEAM"
3110? "EXPLOSION. THE CONTAINER":? "BUILDING HAS RUPTURED. LETHAL"
3120? "RADIOACTIVE GASES AND DEBRIS":? "HAVE ESCAPED."
3150?:? "INITIATE YOUR EVACUATION":? "AND RADIOACTIVE CLEANUP PLANS"
3160? "AND GET MEDICAL ASSISTANCE."
3190GOTO 5000
4000& ***EVALUATION OF GAME RESULTS***
4020?:? "Over a period of "; day%; " days":? "you have produced an average power":? "output of "; kw%; "KW per day."
4050 kw%=1+(kw%>1000)+(kw%>1200)+(kw%>1500)+(kw%>1800)
4070?:? "Your average power production":? "rate is:"
4080ON kw% GOTO 4090, 4100, 4110, 4120, 4140
4090? "Horrible!":? "Find a less demanding job.":GOTO 4200
4100? "way below your area's":? "power needs.":GOTO 4200
4110? "Adequate.":? "you could do better.":GOTO 4200
4120? "EXCELLENT!":? "POWER COSTS IN YOUR AREA"
4130? "WILL NOT BE INCREASED.":GOTO 4200
4140? "Near ther maxinum!":? "Power costs in your"
4150? "AREA WILL DROP SIGNIFICANTLY."
4200& **DAMAGE EVALUATION**
4215?:GOSUB 2000
4220 d%=1+(dmge%>10)+(dmge%>20)+(dmge%>30)
4230? "THE EQUIPMENT DAMAGE SUSTAINED DURING"
4240? "THIS PERIOD WAS "; 
4250ON d% GOTO 4260, 4270, 4280, 4290
4260? "VERY LIGHT.":GOTO 5000
4270? "MODERATE.":GOTO 5000
4280? "HEAVY.":GOTO 5000
4290? "SEVERE."
5000& ***END***
5020?:? "WOULD YOU LIKE TO TRY AGAIN?(Y OR N)"; 
5025NORMAL
5030GET a$
5040IF a$="y" OR a$="Y" THEN GOSUB 2000:GOTO 390
5060HOME:END
5100 b$=""
5105FOR i=1 TO 4
5110GET a$
5130IF ASC(a$)<>32 THEN 5140
5134IF b$="" THEN RETURN
5136 out%=VAL(b$)
5138RETURN
5140IF ASC(a$)=13 THEN POP:GOTO 1170
5150 b$=b$+a$
5160? a$; 
5170NEXT i:RETURN
6000GR:COLOR =15:FOR i=0 TO 39:HLIN 0, 39 AT i:NEXT
6005 de=6000
6010HOME:VTAB 23
6020? "  THIS IS THE REACTOR VESSEL"
6030RESTORE
6035COLOR =1
6040FOR i=1 TO 29
6050READ x1, x2, y
6060HLIN x1, x2 AT y
6070NEXT i
6080DATA  7,9,6,15,17,6,6,18,7,5,19,8,5,7,9,17,19,9,5,6,10,18,19,10,5,6,11,18
6085DATA  19,11,5,6,12,18,19,12,5,6,13,18,19,13,5,6,14,18,19,14,5,6,15,18,19
6090DATA  15,5,6,16,18,19,16,5,6,17,18,19,17,5,6,18,18,19,18,5,7,19,17,19,19
6095DATA  6,18,20,7,17,21,8,16,22
6100COLOR =0
6110HLIN 10, 14 AT 6
6120COLOR =12
6130HLIN 15, 16 AT 5
6140HLIN 15, 16 AT 4
6150HLIN 15, 16 AT 3
6160FOR i=1 TO de:NEXT i
6170VTAB 23
6180? " THIS IS THE REACTOR CORE"
6190COLOR =3
6200FOR i=9 TO 15
6210VLIN 11, 17 AT i
6220NEXT i
6230FOR i=1 TO de:NEXT i
6240VTAB 23
6250? " THESE ARE THE CONTROL RODS"
6260COLOR =13
6270VLIN 2, 17 AT 11
6280VLIN 2, 17 AT 13
6290FOR i=1 TO de:NEXT i
6300VTAB 23
6310? "THE EMERGENCY COOLANT CAN COOL"
6320? "THE REACTOR IN AN EMERGENCY."
6330COLOR =2
6340FOR i=1 TO 36
6350READ y, x
6360PLOT x, y
6370FOR j=1 TO 200:NEXT j
6380NEXT i
6390DATA  4,2,4,4,5,2,5,3,5,4,6,2,6,3,6,4,7,3,8,3,9,3,10,3,11,3,12,3,12,4,12,5,12,6,12,7,12,8,12,9
6400DATA  13,9,14,9,15,9,16,9,16,8,16,7,16,6,16,5,16,4,16,3,17,3,18,3,19,3,20,3,22,3,24,3
6410FOR i=1 TO de:NEXT i
6420HOME:VTAB 23
6430? "THE PRIMARY COOLANT CARRIES":? "HEAT FROM THE REACTOR CORE"
6440? "TO THE HEAT EXCHANGER."
6450FOR i=1 TO 52
6460READ y, x
6470PLOT x, y
6480FOR j=1 TO 200:NEXT j
6490NEXT i
6500FOR i=1 TO de:NEXT i
6510DATA  4,25,4,27,5,25,5,26,5,27,6,25,6,26,6,27,7,26,8,26,9,26,10,26,11,26,12,26,12,25,12,24,12,23,12,22
6515DATA  12,21,12,20,12,19,12,18,12,17,12,16,12,15,13,15,14,15,15,15,16,15,16,16,16,17,16,18,16,19,16,20
6520DATA  16,21,16,22,16,23,16,24,16,25,16,26,16,27,16,28,16,29,16,30,15,30,14,30,13,30,13,30,12,30,12,29
6525DATA  12,28,12,27
6540HOME:VTAB 23
6550? "THIS IS THE HEAT EXCHANGER"
6560COLOR =5
6570HLIN 28, 34 AT 10
6580VLIN 10, 18 AT 34
6590HLIN 28, 34 AT 18
6600VLIN 10, 18 AT 28
6605COLOR =2:PLOT 28, 12:PLOT 28, 16:COLOR =5
6610FOR i=1 TO de:NEXT i
6620VTAB 23
6630? "THIS IS THE GENERATOR TURBINE"
6640HLIN 5, 18 AT 30
6650VLIN 30, 36 AT 18
6660HLIN 5, 18 AT 36
6670VLIN 30, 36 AT 5
6680COLOR =0
6690HLIN 2, 17 AT 33
6700FOR i=7 TO 15 STEP 2
6710PLOT i, 34:PLOT i+1, 32
6720NEXT i
6730FOR i=1 TO de:NEXT i
6740VTAB 23
6750? "THIS IS THE COOLING TOWER"
6760COLOR =5
6770VLIN 23, 25 AT 24
6780VLIN 23, 25 AT 36
6790VLIN 25, 26 AT 25
6800VLIN 25, 26 AT 35
6810VLIN 26, 28 AT 26
6820VLIN 26, 28 AT 34
6830VLIN 28, 36 AT 27
6840VLIN 28, 36 AT 33
6850PLOT 34, 36
6860PLOT 26, 36
6870HLIN 25, 35 AT 38
6880FOR i=1 TO de:NEXT i
6890VTAB 23
6896DATA                   14,38,13,38,12,38,12,37
6900? "THE SECONDARY COOLANT CARRIES"
6910? "HEAT FROM THE HEAT EXCHANGER"
6920? "TO THE TURBINE AND THEN TO":? "THE COOLING TOWER."
6925COLOR =2
6930FOR i=1 TO 123
6940READ y, x
6950PLOT x, y
6960FOR j=1 TO 200:NEXT j
6970NEXT i
6980DATA  4,35,4,37,5,35,5,36,5,37,6,35,6,36,6,37,7,36,8,36,9,36,10,36,11,36,12,36,12,35,12,34,12,33,12,32,13,32,14,32
6981DATA  15,32,16,32,16,33,16,34,16,35,16,36,17,36,18,36,19,36,20,36,20,35,20,34,20,33,20,32,20,31,20
6982DATA  30,20,29,20,28,20,27,20,26,20,25,20,24,20,23,20,22,20,21,21,21,22,21,23,21,24,21,25,21,26,21,27,21,27,20 
6983DATA  27,19,27,18,27,17,27,16,27,15,27,14,27,13,27,12,27,11,27,10,27,9,27,8,27,7,28,7,29,7,30,7,31,7,32,7,34,10
6984DATA  32,13,34,16,35,16,35,17,35,18,35,19,35,20,35,21,35,22,35,23,35,24,35,25,35,26,35,27,35,28,34,28,34,29,34
6985DATA  30,35,30,35,31,35,32,34,32,34,33,34,34,34,35,34,36,34,37,34,38,33,38,32,38,31,38,30,38,29,38,28,38,27,38
6986DATA  26,38,25,38,24,38,23,38,22,38,21,38,20,38,19,38,18,38,17,38,16,38,15,38,14,38,13,38,12,38,12,37
7040HOME:VTAB 23
7060RETURN
8000GR:COLOR =8:FOR i=0 TO 39:HLIN 0, 39 AT i:NEXT i:COLOR =14:FOR i=39 TO 0 STEP -1:HLIN 0, 39 AT i:NEXT i
8010FOR i=1 TO 1000:NEXT i:COLOR =0:HLIN 17, 23 AT 36:COLOR =1:HLIN 16, 24 AT 35:COLOR =3:HLIN 17, 23 AT 34
8020FOR i=1 TO 500:NEXT i:COLOR =13:VLIN 20, 33 AT 19:VLIN 20, 33 AT 21:COLOR =11:VLIN 20, 34 AT 20
8030COLOR =8:HLIN 10, 30 AT 22:HLIN 9, 31 AT 21:COLOR =11:HLIN 8, 32 AT 20:HLIN 7, 33 AT 19
8040COLOR =3:HLIN 6, 34 AT 18:HLIN 5, 35 AT 17:HLIN 4, 36 AT 16:HLIN 3, 37 AT 15
8050COLOR =8:HLIN 3, 37 AT 14:HLIN 4, 36 AT 13:HLIN 5, 35 AT 12:HLIN 6, 34 AT 11:HLIN 7, 33 AT 10
8060COLOR =3:HLIN 8, 32 AT 9:COLOR =11:HLIN 9, 31 AT 8:HLIN 10, 30 AT 7
8070COLOR =3:HLIN 12, 18 AT 19:HLIN 22, 28 AT 19:COLOR =9:HLIN 14, 16 AT 18:HLIN 24, 26 AT 18
8080VTAB (23):HTAB (8)
8090? "     MELTDOWN     ":FOR i=1 TO 1000:NEXT i
8100TEXT:VTAB (12):HTAB (8)
8110FLASH
8120? "     MELTDOWN     "
8130NORMAL
8140FOR i=1 TO 2000:NEXT i
8150RETURN
8151 REM ************************
8152 REM *                      *
8153 REM * DOWNLOADED FROM THE  *
8154 REM * NEW HAMPSHIRE ADAM-  *
8155 REM * SERVE BBS (603) 432- *
8156 REM * 5274                 *
8157 REM *                      *
8158 REM ************************
